\documentclass[a4paper]{article}
\usepackage[left=2.2cm,right=2.2cm,top=2.5cm,bottom=2.5cm]{geometry} % page settings
\usepackage{amsmath}
\usepackage{amssymb}
%\usepackage{amsthm}
%\usepackage{etoolbox}
\usepackage[english]{babel}
\usepackage[utf8]{inputenc}
%\usepackage{framed}
\usepackage{fancyhdr}
%\usepackage{tikz}
\usepackage{graphicx}
\usepackage{subcaption}
\usepackage{hyperref}

\setlength{\parskip}{\medskipamount}
\setlength{\parindent}{0pt}

\pagestyle{fancy}
\lhead{
    \begin{tabular}{ll}
      Lab Course Deep Learning \\
      Winter term 2017/18
  \end{tabular}
}
\chead{}
\rhead{
  \begin{tabular}{ll}
    Fabian Glöckle \\
    20/11/2017
  \end{tabular}
}
\lfoot{}
\cfoot{}
\rfoot{} 


\begin{document}

\title{Deep Learning Lab Course Report 2}
\author{Fabian Glöckle}
\date{\today}
% \maketitle

\subsection*{A CNN in Tensorflow}

In this exercice, we implemented a simple CNN like LeNet and applied it to the MNIST dataset. The code can be found on my github repo \footnote{\url{https://gitlab.com/fabian.g/deep-learning/tree/master}}.

\subsubsection*{Architecture}
\begin{itemize}
  \item Convolutional layer with 16 filters and ReLU activation.
  \item Max pooling layer.
  \item Convolutional layer with 16 filters and ReLU activation.
  \item Max pooling layer.
  \item Fully connected layer with 128 units.
  \item Softmax output layer. 
\end{itemize}

The network is trained with stochastic gradient descent with minbatches of size 64. Around 7800 minibatch epochs were run per tested learning rate.

\subsubsection*{Problems with variable architecture}

In exercise 3, I could not find out how to easily make the number of filters a hyperparameter to be set at initialization time. Using tensorflow placeholders / variables does not work as tensorflow needs to create a fixed computational graph. Tensorflow constants are not made for this neither. Easiest is probably to return a whole network / computational graph by a function. But what needs to be returned? Simply returning variables like \texttt{train} or \texttt{accuracy} that are later evaluated in the session, did not work. Maybe the only option is to return an estimator object as in the tutorial online \footnote{\url{https://www.tensorflow.org/tutorials/layers\#building_the_cnn_mnist_classifier}}.

\subsubsection*{Results}

\begin{figure}[h!] 
\includegraphics[width=\textwidth]{plots.png} 
\caption{Training curves for different learning rates. Blue: 0.1, green: 0.01, red: 0.001, cyan: 0.0001.}
\label{fig}
\end{figure}

Figure 1 shows the accuracy of the network on the validation dataset. After around 2000 minibatch epochs, it reaches an accuracy of approximately 98 per cent, similar to the MLP. The architecture tough has not been tuned well and accoring to literature, it can be expected that even 99 per cent can be reached.

The graph shows increasing accuracy with increasing learning rate. The network with a learning rate of just 0.0001 is even not close to good after more than 7000 minibatch epochs. However, increasing the learning rate is not universally good: with higher values, I also observed high instability. (Unfortunately not saved.)

I could not run the runtime tests due to the problems described above. To estimate the runtime complexity, we note: the number of filters per layer linearly increases the runtime as simply linearly more convolutions need to be calculated. Additionally, increasing the number of filters per layer also linearly increases the number of operations per convolution, as more channels are involved. Together, I thus expect quadratic dependence.


\end{document}
